package backend

import . "gitlab.com/beoran/ebsgo/zori/types"
import "gitlab.com/beoran/ebsgo/zori/event"


type Loader interface {
    Bitmap(name string) (Bitmap, error)
    Font(name string) (Bitmap, error)
}

type Drawer interface {
    Bitmap(x, y int, bitmap Bitmap)
    ScaledBitmap(x, y, dw, dh int, bitmap Bitmap)
    Rectangle(x, y, w, h int, color Color)
    Slab(x, y, w, h int, color Color)
    RoundedRectangle(x, y, w, h, rx, ry int, color Color)
    RoundedSlab(x, y, w, h, rx, ry int, color Color)
}


type Poller interface {
    Empty() bool
    Poll() event.Event
}

type Backend interface {
    Display()   Display
    Load()      Loader
    Draw()      Drawer
    Queue()     Poller
    Close()
}
