package widget

import "fmt"
import . "gitlab.com/beoran/ebsgo/zori/types"
// import _ "gitlab.com/beoran/ebsgo/zori/backend"
import "gitlab.com/beoran/ebsgo/zori/state"
import  "gitlab.com/beoran/ebsgo/zori/style"
import "gitlab.com/beoran/ebsgo/zori/event"


type Basic struct {
    ID    int
    Root  Widget
    Box
    Outer Box
    Inner Box
    Z     int
    style.BasicThemed
    Parent   Widget
    Children []Widget
    state.Flag
    Result  interface{}
}
                                                                        
func (bw *Basic) Update(ev event.Update) event.Result                         { fmt.Println("Update"); return event.Result(false); }
func (bw *Basic) Draw(ev event.Draw) event.Result                             { fmt.Println("Draw"); return event.Result(false); }
func (bw *Basic) Resize(ev event.Resize) event.Result                             { fmt.Println("Resize"); return event.Result(false); }
func (bw *Basic) Destroy(ev event.Destroy) event.Result                       { fmt.Println("Destroy"); return event.Result(false); }
func (bw *Basic) Action(ev event.Action) event.Result                         { fmt.Println("Action"); return event.Result(false); }
func (bw *Basic) Close(ev event.Close) event.Result                           { fmt.Println("Close"); return event.Result(false); }
func (bw *Basic) NewChild(ev event.NewChild) event.Result                     { fmt.Println("Child"); return event.Result(false); }
func (bw *Basic) JoyButtonPress(ev event.JoyButtonPress) event.Result         { fmt.Println("JBP"); return event.Result(false); }
func (bw *Basic) JoyButtonRelease(ev event.JoyButtonRelease) event.Result     { fmt.Println("JBR"); return event.Result(false); }
func (bw *Basic) JoyAxis(ev event.JoyAxis) event.Result                       { fmt.Println("JAX"); return event.Result(false); }
func (bw *Basic) KeyPress(ev event.KeyPress) event.Result                     { fmt.Println("KEP"); return event.Result(false); }
func (bw *Basic) KeyRelease(ev event.KeyRelease) event.Result                 { fmt.Println("KER"); return event.Result(false); }
func (bw *Basic) MouseAxes(ev event.MouseAxes) event.Result                   { fmt.Println("MAX"); return event.Result(false); }
func (bw *Basic) MouseWarped(ev event.MouseWarped) event.Result               { fmt.Println("MWA"); return event.Result(false); }
func (bw *Basic) MouseButtonPress(ev event.MouseButtonPress) event.Result     { fmt.Println("MBP"); return event.Result(false); }
func (bw *Basic) MouseButtonRelease(ev event.MouseButtonRelease) event.Result { fmt.Println("MBR"); return event.Result(false); }
func (bw *Basic) MouseEnterDisplay(ev event.MouseEnterDisplay) event.Result   { fmt.Println("MED"); return event.Result(false); }
func (bw *Basic) MouseLeaveDisplay(ev event.MouseLeaveDisplay) event.Result   { fmt.Println("MLD"); return event.Result(false); }
func (bw *Basic) TouchBegin(ev event.TouchBegin) event.Result                 { fmt.Println("TB"); return event.Result(false); }
func (bw *Basic) TouchEnd(ev event.TouchEnd) event.Result                     { fmt.Println("TE"); return event.Result(false); }
func (bw *Basic) TouchMove(ev event.TouchMove) event.Result                   { fmt.Println("TM"); return event.Result(false); }
func (bw *Basic) TouchCancel(ev event.TouchCancel) event.Result               { fmt.Println("TC"); return event.Result(false); }

func (bw *Basic) Default(ev event.Event) event.Result { 
    fmt.Println("Warning using default event handler!"); 
    return event.Result(false); 
}

func (bw *Basic) KeyChar(kc event.KeyChar) event.Result {
    fmt.Println("KeyChar of Basic")
    return event.Result(true)
}

// Checks if the coordinates are inside the main rectange of the widget.
func (bw *Basic) IsInside(x, y int) bool {
    return (x >= bw.X) && (x <= bw.X + bw.W) && (y >= bw.Y) && (y <= (bw.Y + bw.H))
}

func (bw * Basic) Dispatch(ev event.Event) event.Result {
    return event.Dispatch(ev, bw)
}

